unit Atualiza_Ftp;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, IdBaseComponent,
  IdComponent, IdTCPServer, IdFTPServer, IdTCPConnection, IdTCPClient,
  IdFTP, ThreadAtualiza, Gauges, IdUDPBase, IdUDPClient, IdTrivialFTP, dateutils,
  Buttons, zBtn, IniFiles, idftpcommon, Funcoes;

const
  _C = 'tYk*5W@';
type
  TFAtualiza_Ftp = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    ftpupdate: TIdFTP;
    lblcontador: TLabel;
    Gauge1: TGauge;
    StatusBar1: TStatusBar;
    lblstatus: TLabel;
    bconfigurar: TButton;
    batualizar: TButton;
    bfechar: TButton;
    procedure ftpupdateWork(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCount: Integer);
    procedure ftpupdateWorkBegin(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCountMax: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ftpupdateStatus(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: string);
    procedure ftpupdateWorkEnd(Sender: TObject; AWorkMode: TWorkMode);
    procedure IdTCPClient1Connected(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure bconfigurarClick(Sender: TObject);
    procedure batualizarClick(Sender: TObject);
    procedure bfecharClick(Sender: TObject);
    procedure Verificaversao;
    procedure GeraINI;
    procedure Atualiza;
    procedure FormActivate(Sender: TObject);


  private
    STime: TDateTime;
    fsHashSenha: Integer;
    { Private declarations }
  public

    BytesToTransfer: longword;
    { Public declarations }
  end;

var
  FAtualiza_Ftp: TFAtualiza_Ftp;
  threadftp: threadupdate;
  AverageSpeed: Double = 0;
  pasta: string;
  Atual, Novo: TDatetime;

implementation

uses Configurar, zFun, zEnv;

{$R *.dfm}

function StrCrypt(const AString, StrChave: AnsiString): AnsiString;
var
  i, TamanhoString, pos, PosLetra, TamanhoChave: Integer;
  C: AnsiString;
begin
  Result := AString;
  TamanhoString := Length(AString);
  TamanhoChave := Length(StrChave);

  for i := 1 to TamanhoString do
  begin
    pos := (i mod TamanhoChave);
    if pos = 0 then
      pos := TamanhoChave;

    posLetra := ord(Result[i]) xor ord(StrChave[pos]);
    if posLetra = 0 then
      posLetra := ord(Result[i]);

    C := AnsiChar(chr(posLetra));
    Result[i] := C[1];
  end;
end;

function LeINICrypt(INI: TIniFile; Section, Ident, Pass: string): string;
var SStream: TStringStream;
  CryptStr: string;
begin
  SStream := TStringStream.Create('');
  try
    INI.ReadBinaryStream(Section, Ident, SStream);
    CryptStr := SStream.DataString;
    Result := StrCrypt(CryptStr, Pass);
  finally
    SStream.Free;
  end;
end;

{------------------------------------------------------------------------------}

procedure GravaINICrypt(INI: TIniFile; Section, Ident, AString, Pass: string);
var SStream: TStringStream;
  CryptStr: string;
begin
  CryptStr := StrCrypt(AString, Pass);
  SStream := TStringStream.Create(CryptStr);
  try
    INI.WriteBinaryStream(Section, Ident, SStream);
  finally
    SStream.Free;
  end;
end;
{-----------------------------------------------------------------------------
  Completa <AString> com <Caracter> a esquerda, at o tamanho <nLen>, Alinhando
  a <AString> a Direita. Se <AString> for maior que <nLen>, ela ser truncada
 ---------------------------------------------------------------------------- }

function padR(const AString: AnsiString; const nLen: Integer;
  const Caracter: AnsiChar): AnsiString;
begin
  Result := copy(AString, 1, nLen);
  if Length(Result) < nLen then
    Result := StringOfChar(Caracter, (nLen - Length(Result))) + Result;
end;

{-----------------------------------------------------------------------------
  Insere ZEROS (0) a esquerda de <Texto> at completar <Tamanho>
 ---------------------------------------------------------------------------- }

function Poem_Zeros(const Texto: AnsiString; const Tamanho: Integer): AnsiString;
begin
  Result := PadR(Trim(Texto), Tamanho, '0');
end;

{-----------------------------------------------------------------------------
  Transforma <NumInteiro> em String, preenchendo com Zeros a Esquerda at
  atingiros digitos de <Tamnho>
 ---------------------------------------------------------------------------- }

function IntToStrZero(const NumInteiro: Int64; Tamanho: Integer): AnsiString;
begin
  Result := '';
  try
    Result := IntToStr(NumInteiro);
    Result := Poem_Zeros(Result, Tamanho);
  except
  end;
end;

function CriaDir(dirNome: string): string;
begin
  pasta := GetPath(Application.ExeName) + dirNome + '\';
  CreateDirectory(PAnsiChar(pasta), nil);
end;

procedure TFAtualiza_Ftp.ftpupdateWork(Sender: TObject;
  AWorkMode: TWorkMode; const AWorkCount: Integer);
var contador, kbTotal, kbTransmitidos, kbFaltantes, Tamanho: Integer;
  media: real;
  S: string;
  TotalTime: TDateTime;
  H, M, Sec, MS: Word;
  DLTime: Double;
begin
  kbTotal := BytesToTransfer div 1024;
  TotalTime := Now - STime;
  DecodeTime(TotalTime, H, M, Sec, MS);
  Sec := Sec + M * 60 + H * 3600;
  DLTime := Sec + MS / 1000;
  //kbTotal := Tamanho div 1024;
  KbTransmitidos := AWorkCount div 1024;
  kbFaltantes := kbTotal - kbTransmitidos;
  // Application.ProcessMessages;
  lblcontador.Caption := 'Transferidos: ' + formatfloat('##,###,##0', kbTransmitidos) + ' Kb de ' + formatfloat('##,###,##0', kbTotal) + ' Kb';
  //ProgressBar1.Position:=Aworkcount;
  media := (100 / BytesToTransfer) * AWorkCount;
  if DLTime > 0 then
  begin
    // Sec := Trunc(((BytesToTransfer - AWorkCount) / 1024) / AverageSpeed);
    AverageSpeed := {(AverageSpeed + }(AWorkCount / 1024) / DLTime {) / 2};
    S := Format('%2d:%2d:%2d', [Sec div 3600, (Sec div 60) mod 60, Sec mod 60]);
    S := 'Tempo de download ' + S;
    //   lblstatus.caption:=s;
  end;
  //  else S := '';
  S := 'Taxa de Transferencia: ' + FormatFloat('0.00 KB/s', AverageSpeed) + '; ' + S;
  lblstatus.caption := s;
  Application.ProcessMessages;
  contador := trunc(media);
  gauge1.Progress := (contador);
  //ProgressBar2.Position:=  (contador);

end;

procedure TFAtualiza_Ftp.ftpupdateWorkBegin(Sender: TObject;
  AWorkMode: TWorkMode; const AWorkCountMax: Integer);
begin
  STime := Now;
  AverageSpeed := 0;
end;

procedure TFAtualiza_Ftp.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  threadftp.Free;
end;

procedure TFAtualiza_Ftp.ftpupdateStatus(ASender: TObject;
  const AStatus: TIdStatus; const AStatusText: string);
begin
  case aStatus of
    hsResolving: statusbar1.Panels[0].text := 'Resolvendo..';
    hsConnecting: statusbar1.Panels[0].text := 'Conectando..';
    hsConnected: statusbar1.Panels[0].text := 'Conectado ao Servidor FTP! Aguarde..';
    hsDisconnecting: statusbar1.Panels[0].text := 'Desconectando..';
    hsDisconnected: begin

        statusbar1.Panels[0].text := 'Desconectado!';
        gauge1.Progress := 100;
      end;
    ftpTransfer: statusbar1.Panels[0].text := 'Transferindo..';
    ftpReady: statusbar1.Panels[0].text := 'Lendo...';
    ftpAborted: statusbar1.Panels[0].text := 'Abortado!';
  else
    statusbar1.Panels[0].text := AStatusText;
  end; //fim do case
end;

procedure TFAtualiza_Ftp.ftpupdateWorkEnd(Sender: TObject;
  AWorkMode: TWorkMode);
begin
  case AWorkMode of
    wmRead: lblstatus.Caption := 'Download!!';
    wmWrite: lblstatus.Caption := 'Upload!!';
  end;
  //  lblcontador.Caption := 'Transferidos: '+ formatfloat('##,###,##0', kbTransmitidos ) +                    ' Kb de ' + formatfloat('##,###,##0', kbTotal) + ' Kb';
  //  ProgressBar1.Position := ProgressBar1.Max;
  lblcontador.Caption := 'Transferidos: ' + formatfloat('##,###,##0', BytesToTransfer div 1024) + ' Kb';
end;

procedure TFAtualiza_Ftp.IdTCPClient1Connected(Sender: TObject);
begin
  showmessage('Conectado');
end;

procedure TFAtualiza_Ftp.FormShow(Sender: TObject);
begin
  GeraINI;
  BytesToTransfer := 0;
end;

procedure TFAtualiza_Ftp.bconfigurarClick(Sender: TObject);
begin
  FConfigurar := TFConfigurar.create(self);
  FConfigurar.showmodal;
  FConfigurar.free;
end;


procedure TFAtualiza_Ftp.Atualiza;
const
  exe = 'contauto.exe';
var
  data, data1: string;
  exe2: TDatetime;
  Dias: currency;
begin
Verificaversao;

  Atual := FileDateToDateTime(FileAge(exe));
  exe2 := Novo; //:= ftpupdate.DirectoryListing.Items[0].ModifiedDate;
  //D2 := ftpupdate.DirectoryListing.Items[1].ModifiedDate;

  //Aumentar a preciso para segundos
  //If Abs(Atual - exe2)  < (1 / 1440 * 60) then

  //Um dia tem 1440 minutos, logo se a diferena entre as duas datas for menor que 1 minuto ele executar o cdigo.
  //OBs inverter o sinal < pra verificar no servidor
  if Abs(Atual - exe2) > (1 / 1440) then
  begin
    // if MessageDlg('Uma nova verso deste Aplicatico est disponvel na Web, deseja atualizar ???', mtconfirmation, [mbok, mbcancel], 0 = mbok then
    if MESSAGEBOX(Application.Handle, 'Uma nova verso deste Aplicatico est disponvel na Web, deseja atualizar ???', 'Atualizao',
      MB_ICONQUESTION + MB_YESNO + MB_DEFBUTTON2) = ID_YES then
    begin
      //Gera .ini
      GeraINI;

      if not ftpupdate.Connected then
      begin
        threadftp := threadupdate.Create(true);
        threadftp.Resume;
      end
      else
        showmessage('Conectado no FTP');
    end else FAtualiza_Ftp.close;
  end else begin
    MESSAGEBOX(Application.Handle, 'Nem uma Atualizao disponivel no Momento???', 'Atualizao', MB_ICONQUESTION + MB_OK);
    FAtualiza_Ftp.close;
  end;
  {//Gera .ini
    GeraINI;

  if not ftpupdate.Connected then
  begin
    threadftp := threadupdate.Create(true);
    threadftp.Resume;
  end
  else
    showmessage('Conectado no FTP');  }
end;

procedure TFAtualiza_Ftp.batualizarClick(Sender: TObject);

begin
  Verificaversao;
  Atualiza;
end;

procedure TFAtualiza_Ftp.bfecharClick(Sender: TObject);
begin
  // fecha se no estiver conectado
  if not ftpupdate.Connected then
  begin
    close;
  end else begin // se estiver conectado fecha a conexo e o formulario
    ftpupdate.Disconnect;
    close;
  end;
end;

procedure TFAtualiza_Ftp.Verificaversao;
var
  LS: TStringList;
  I: Integer;
  Name, DirCorrente, passivo: string;
  ServerIni: TIniFile;
begin
  // Cria lista de aqruivos do ftp
  GeraINI;

  LS := TStringList.Create;
  //localiza o .ini
  ServerIni := TIniFile.Create(ExtractFilePath(ParamStr(0)) + 'Atualiza.ini');
  passivo := ServerIni.ReadString('CONEXAO', 'PASSIVO', '');

  with FAtualiza_Ftp do
  begin
    // passa as configuraes do Atualiza.ini para o componente IdFTP(ftpupdate)
    ftpupdate.Host := ServerIni.ReadString('CONEXAO', 'FTP', '');
    ftpupdate.Username := ServerIni.ReadString('CONEXAO', 'USUARIO', '');
    ftpupdate.Password := ServerIni.ReadString('CONEXAO', 'PASSWD', '');
    //ftpupdate.Password := LeINICrypt(ServerIni, 'CONEXAO', 'PASSWD', _C);
    if passivo = 'S' then
      ftpupdate.Passive := true
    else
      ftpupdate.passive := false;

    ServerIni.Free;
    ftpupdate.Connect();
    //ftpupdate.list(memo1.Lines);
  end;
  // faz a verificao do executavel no ftp data da modificao para comparar com o exe atual
  try
    // ftBinary ou ftASCII, basta incluir na uses do form, a unit: idftpcommon
    ftpupdate.TransferType := ftBinary;
    DirCorrente := ftpupdate.RetrieveCurrentDir;
    // lista filtrando
    ftpupdate.List(LS, 'contauto.exe', True); // mascara  o filtro, tipo *.EXE
    // /Carrega a lista de Arquivos encontrados no FTP
    for I := 0 to LS.Count - 1 do begin
      Name := ftpupdate.DirectoryListing.Items[I].FileName;
      Novo := ftpupdate.DirectoryListing.Items[I].ModifiedDate;
    end;
  finally
    LS.Free;
    ftpupdate.Disconnect;
  end;

end;

// Gera diretorio e *.ini de configurao

procedure TFAtualiza_Ftp.GeraINI;
var
  local: string;
  ServerIni: TIniFile;
  passivo: string;
begin
  local := GetCurrentDir;
  if not (DirectoryExists(local + '\Atualizacao')) then
    CriaDir('Atualizacao');

  if not (fileexists(local + '\Atualiza.ini')) then
  begin
    passivo := 'N';
    ServerIni := TIniFile.Create(ExtractFilePath(ParamStr(0)) + 'Atualiza.ini');
    ServerIni.WriteString('CONEXAO', 'FTP', '201.33.227.181');
    ServerIni.WriteString('CONEXAO', 'USUARIO', 'autosistem');
    ServerIni.WriteString('CONEXAO', 'PASSWD', 'teste');
    //GravaINICrypt(ServerIni, 'CONEXAO', 'PASSWD', IntToStrZero(fsHashSenha, 8), _C);
    ServerIni.WriteString('CONEXAO', 'PASSIVO', passivo);
    ServerIni.WriteString('CONEXAO', 'SALVAR', local + '\Atualizacao\');
    ServerIni.WriteString('CONEXAO', 'ARQUIVO', 'contauto.exe');
    ServerIni.UpdateFile;
    ServerIni.Free;
  end;
end;


procedure TFAtualiza_Ftp.FormActivate(Sender: TObject);
begin
  //if FMain.Tipo = '0' then
     //begin
       //batualizar.Caption:= '&Atualizar';
       //Label2.Caption:='Para acessar o Sistema  necessria a atualizao';
       //bfechar.Enabled:=False;
     //end else begin
  //batualizar.Caption := 'Verificar Atualizaes';
  //Label2.Caption := 'O programa ir verificar nova verso do sistema no Servidor.';
  //end;
end;

end.

