unit Funcoes;

interface
uses SysUtils, IniFiles, Classes;
implementation

function StrCrypt(const AString, StrChave: AnsiString): AnsiString;
var
  i, TamanhoString, pos, PosLetra, TamanhoChave: Integer;
  C: AnsiString;
begin
  Result := AString;
  TamanhoString := Length(AString);
  TamanhoChave := Length(StrChave);

  for i := 1 to TamanhoString do
  begin
    pos := (i mod TamanhoChave);
    if pos = 0 then
      pos := TamanhoChave;

    posLetra := ord(Result[i]) xor ord(StrChave[pos]);
    if posLetra = 0 then
      posLetra := ord(Result[i]);

    C := AnsiChar(chr(posLetra));
    Result[i] := C[1];
  end;
end;

function LeINICrypt(INI: TIniFile; Section, Ident, Pass: string): string;
var SStream: TStringStream;
  CryptStr: string;
begin
  SStream := TStringStream.Create('');
  try
    INI.ReadBinaryStream(Section, Ident, SStream);
    CryptStr := SStream.DataString;
    Result := StrCrypt(CryptStr, Pass);
  finally
    SStream.Free;
  end;
end;

{------------------------------------------------------------------------------}

procedure GravaINICrypt(INI: TIniFile; Section, Ident, AString, Pass: string);
var SStream: TStringStream;
  CryptStr: string;
begin
  CryptStr := StrCrypt(AString, Pass);
  SStream := TStringStream.Create(CryptStr);
  try
    INI.WriteBinaryStream(Section, Ident, SStream);
  finally
    SStream.Free;
  end;
end;
{-----------------------------------------------------------------------------
  Completa <AString> com <Caracter> a esquerda, at o tamanho <nLen>, Alinhando
  a <AString> a Direita. Se <AString> for maior que <nLen>, ela ser truncada
 ---------------------------------------------------------------------------- }
function padR(const AString : AnsiString; const nLen : Integer;
   const Caracter : AnsiChar) : AnsiString ;
begin
  Result := copy(AString,1,nLen) ;
  if Length(Result) < nLen then
     Result := StringOfChar(Caracter, (nLen - Length(Result))) + Result ;
end ;

{-----------------------------------------------------------------------------
  Insere ZEROS (0) a esquerda de <Texto> at completar <Tamanho>
 ---------------------------------------------------------------------------- }

function Poem_Zeros(const Texto: AnsiString; const Tamanho: Integer): AnsiString;
begin
  Result := PadR(Trim(Texto), Tamanho, '0');
end;

{-----------------------------------------------------------------------------
  Transforma <NumInteiro> em String, preenchendo com Zeros a Esquerda at
  atingiros digitos de <Tamnho>
 ---------------------------------------------------------------------------- }

function IntToStrZero(const NumInteiro: Int64; Tamanho: Integer): AnsiString;
begin
  Result := '';
  try
    Result := IntToStr(NumInteiro);
    Result := Poem_Zeros(Result, Tamanho);
  except
  end;
end;
end.

